//+------------------------------------------------------------------+
//|                                             Brent-WTI Spread.mq5 |
//|                                  Copyright 2024, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2024, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <Graphics\Graphic.mqh>
//Set this value between 0 and 1 to control how much data is used
double consumption = 1.0;
int brent_bars = (int) NormalizeDouble((iBars("UK Brent Oil",PERIOD_CURRENT) * consumption),0);
int wti_bars = (int) NormalizeDouble((iBars("WTI_OIL",PERIOD_CURRENT) * consumption),0);
//We want to know which symbol has the least number of bars.
int max_bars = (brent_bars < wti_bars) ? brent_bars : wti_bars;

void OnStart()
  {
      CGraphic graphic;
      double from = 0;
      double to  = max_bars;
      double step = 1;
      graphic.Create(0,"G",0,0,0,600,200);
      CColorGenerator generator;
      uint spread = generator.Next();
      CCurve *curve = graphic.CurveAdd(SpreadFunction,from,to,step,spread,CURVE_LINES,"Blue");
      curve.Name("Spread");
      graphic.XAxis().Name("Time");      
      graphic.XAxis().NameSize(12);  
      graphic.YAxis().Name("Brent-WTI Spread");      
      graphic.YAxis().NameSize(12);  
      graphic.CurvePlotAll();
      graphic.Update();
  }
//+------------------------------------------------------------------+

double SpreadFunction(double x)
   {
      return(iClose("UK Brent Oil",PERIOD_CURRENT,(max_bars - x)) - iClose("WTI_OIL",PERIOD_CURRENT,(max_bars - x)));
   }
